

import java.io.*; 
class Corredor{
	// Datos del corredor
	protected String nombre; 
	protected int edad; 
	protected char categoria; 
	protected char sexo; 
	protected int minutos; 
	protected int segundos;

	// Datos del archivo
	protected File file;
	protected FileOutputStream miArch;
	protected DataOutputStream salida;
	protected BufferedReader entrada;
	
	public Corredor(){		// Constructor
		miArch  = null;	// Inicializando referencias
		entrada = null;
		salida  = null;
		file 	= null;
	}

	public boolean leerDatos()throws IOException{
		System.out.print("Nombre: ");
		nombre = In.readLine();
		if (nombre.length() > 0){
			System.out.print("Edad: ");
			edad = In.readInt();
			if (edad >= 40) categoria = 'V';
			else 			categoria = 'S';
			System.out.print("Sexo,(M,F): ");
			sexo = In.readChar();
			System.out.print("Minutos:  ");
			minutos = In.readInt();
			System.out.print("Segundos: ");
			segundos = In.readInt();
			return true;
		}
		else return false;
	}

	// mtodo para escribir en el flujo
	public void grabarDatos () throws IOException{
		salida.writeUTF(nombre);
		salida.writeInt(edad);
		salida.writeChar(categoria);
		salida.writeChar(sexo);
		salida.writeInt(minutos);
		salida.writeInt(segundos);
	}

	public void crearArchivo(){
		System.out.println("Generando archivo de corredores");
		System.out.print("Nombre archivo: ");
		String nomeArch = In.readLine();
		nomeArch+=".dat";
		file    = new File(nomeArch);		//	Instanciando objeto File
		if (file.exists())		
		 	System.out.println("(Ok: Archivo creado)");
		try{
			miArch = new FileOutputStream(file);
			salida = new DataOutputStream(miArch);
			entrada = new BufferedReader(
					new InputStreamReader(System.in));
		}
		catch (IOException e){System.out.println("Excepcin creando archivo");}
		System.out.println("Informe datos del corredor");
		System.out.println("Para terminar, Nombre:<ENTER>");
		file = new File("Corredores.dat");
		try{
			boolean mas = true;
			miArch = new FileOutputStream(file);
			salida = new DataOutputStream(miArch);
			BufferedReader entrada = new BufferedReader(
					new InputStreamReader(System.in));
			while (mas){
				mas = leerDatos(); 
				if (mas) grabarDatos();
			}
			miArch.close();
		}
		catch (IOException e){System.out.println("Excepcin de Entrada/Salida");}
	}

	public static void main(String[] args){
		Corredor corr = new Corredor();
		corr.crearArchivo();
	}
}	
