// clase para realizar consultas 
import java.io.*;
import In;
class ConsultaCountry{
	private RandomAccessFile archivo;
	
	private void mostrar(MiCasona reg){
		System.out.println(reg.nombreCasa +
			" ubicada en las coordenadas (" + (float)reg.x + ", " + (float)reg.y +")");
	}

	public ConsultaCountry(File f) throws IOException{
		if (f.exists()){
			archivo = new RandomAccessFile(f,"r"); 
			System.out.println("Flujo abierto en modo lectura, tamao: " 
			+ archivo.length());
		} 
		else{
			archivo = null;
			throw new IOException ("Archivo no existe. ");
		}
	}
	public void consultaGeneral() throws IOException{
		if (archivo != null){
			try{
				int n = 0;
				MiCasona reg = new MiCasona();
				while (true){
					archivo.seek(reg.desplazamiento(++n)) ;
					if(reg.leerReg(archivo))	// lectura sin error
						if (reg.numOrden > 0) mostrar(reg) ; // registro activo
				}
			}
			catch(EOFException eof){
				System.out.println("\n Se alcanza el fin del archivo" +
					 				" en la consulta ");
			}
		}
	}
	
	public void consultaReg(int nreg) throws IOException{
		if (archivo != null){
			MiCasona reg = new MiCasona();
			if (nreg>0 && reg.desplazamiento(nreg)< archivo.length()){
				archivo.seek(reg.desplazamiento(nreg));
				if (reg.leerReg(archivo))
					if (reg.numOrden > 0)
						mostrar(reg);
					else
						System.out.println("Registro " + nreg +
											" no dado de alta.");
			}
			else throw new IOException(" Registro fuera de rango.");
		}
	}
			
	public static void main(String []args){
		File f = new File("MiCountry.dat");
		ConsultaCountry clta = null;
		int opc = 1;
		BufferedReader entrada = new BufferedReader(
			new InputStreamReader(System.in));
		try{
			System.out.println("\n Consultas al archivo" +
			f.getName());
			clta = new ConsultaCountry(f); 
			while (opc != 5){
				System.out.println("1.Muestra registros activos.") ;
				System.out.println("2.Muestra un registro determinado."); 
				System.out.print  ("5.Se sale de la aplicacin.");
				do{
					opc = In.readInt();
				}while ((opc < 1) || (opc > 2 && opc != 5));
				if (opc ==1)
					clta.consultaGeneral();
				else if (opc ==2){
						int nreg;
						System.out.print("Nmero de registro: "); 
						nreg = In.readInt(); 
						clta.consultaReg(nreg);
				}
			}
		}
		catch(IOException e){
			System.out.println("\n Excepcin duranteconsulta:" +
				e.getMessage() + " Termina la aplicacin.");
		}
	}
}